/**
 * SO, 2010 - Lab 2, Simple I/O
 * Task #2, Linux
 *
 * Full length read/write 
 */

#include "xfile.h"
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#define BUF_SIZE 1024

/** 
 * xread/xwrite test program 
 */
int main(int argc, char **argv) {
	int fd, i;
	char buf[BUF_SIZE];

	for (i = 0; i < BUF_SIZE; i++)
		buf[i] = i % 256;

	fd = open("xtest.bin", O_WRONLY | O_CREAT | O_TRUNC, 0644);
	if (fd < 0) {
		perror("open(1)");
		return -1;
	}

	if (xwrite(fd, buf, BUF_SIZE) != BUF_SIZE) {
		perror("xwrite(1)");
		return -1;
	}

	if (close(fd) < 0) {
		perror("close(1)");
		return -1;
	}

	fd = open("xtest.bin", O_RDONLY);
	if (fd < 0) {
		perror("open(2)");
		return -1;
	}
    
	for (i = 0; i < BUF_SIZE; i++)
        	buf[i] = (i + 1) % 256;

	if (xread(fd, buf, BUF_SIZE) != BUF_SIZE) {
		perror("xread(1)");
		return -1;
	}

	if (close(fd) < 0) {
		perror("close(2)");
	}

	for (i = 0; i < BUF_SIZE; i++)
		if (buf[i] != (char)(i % 256)) {
			printf("Data mismatch, you may want to review your xread/xwrite implementation\n");
			return -1;
		}

	printf("Alles OK!\n");
	return 0;
}

