/**
 * SO, 2010 - Lab #2, Simple I/O
 * Task #3, Linux
 *
 * mcat - read a file and print on the standard output 
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#define BUF_SIZE 8

int main(int argc, char *argv[])
{
	int fd, bytes_read, eof = 0;
	char buf[BUF_SIZE];
	
	if (argc != 2) {
		fprintf(stderr,"Usage: ./mcat <file>\n");
		exit(EXIT_FAILURE);
	}
	
	/* open file with name pointed by argv[1] */
	fd = open(argv[1], O_RDONLY);
	if (fd < 0) {
		perror("open");
		exit(EXIT_FAILURE);
	}

	/* read file pointed by argv[1] and send it to standadard output *
	 * WARN: you must read at most BUF_SIZE bytes at a time
       	 */
        while (!eof) {
                int bytes_read = xread(fd, buf, BUF_SIZE);
		if (bytes_read < 0) {
			perror("xread");
			return -1;
		}
                if (bytes_read == 0) {
                        eof = 1;
                } else {
                        if (xwrite(STDOUT_FILENO, buf, bytes_read) < 0) {
                                perror("xwrite");
                                return -1;
                        }
                }
        }

	return 0;
}
