/**
 * SO, 2010 - Lab #2, Simple I/O
 * Task #4, Linux
 *
 * Standard output/error redirection
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

int io_redirect(const char *file) 
{
	int fd;

	/* 
         * open @file for write + append, 
	 * also create the file if it doesn't exits
         */	
        fd = open(file, O_CREAT | O_RDWR | O_APPEND, 0644);
        if(fd < 0) {
                perror("open:");
                exit(EXIT_FAILURE);
        }

	dup2(fd, STDOUT_FILENO);
        dup2(fd, STDERR_FILENO);

	return 0;

}
	
	
int main(void)
{
	int ret; 
	
	ret = io_redirect("log");
	
	if (ret < 0) {
		perror("io_redirect");
		exit(EXIT_FAILURE);
	}
	
	fprintf(stdout, "Lab #2\n");
	fprintf(stderr, "SO :)\n");

	return 0;
}

	
