/** 
 * SO, 2010 - Lab #2, Simple I/O
 * Task #1, Windows
 *
 * Reading a character from a specified position 
 */

#include <windows.h>
#include <stdio.h>

static int pos[] = 
{ 
	100, 200, 300, 400, 500, 600, 700, 800, 900, 
	1000, 1100, 1200, 1300, 1400, 1500, 1600, 1700, 1800, 1900,
	2000, 2100, 2200, 2300, 2400, 2500, 2600, 2700, 2800, 2900,
	3000, 3100, 3200, 3300  
};

int main(void)
{
	HANDLE fHandle;
	char c;
	DWORD bytesRead;
	int i;
	
	/* open quotes.txt for reading */
	fHandle = CreateFile("quotes.txt",
			GENERIC_READ,
			0,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL);
	if (fHandle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "Error opening file %d\n", GetLastError());
		ExitProcess(1);
	}
	
	/* 
	 * read characters from positions specified by pos 
	 * and write them to standard output
         */	
	for (i = 0; i < sizeof(pos)/sizeof(pos[0]); i++) {
		SetFilePointer(fHandle,
				pos[i],
				NULL,
				FILE_BEGIN);
		if (ReadFile(fHandle,
				&c,
				1,
				&bytesRead,
				NULL) == FALSE) {
			fprintf(stderr, "Error reading file %d\n", GetLastError());
			ExitProcess(1);
		}
		if (bytesRead != 1) {
			fprintf(stderr, "Error reading file.\n");
			ExitProcess(1);
		}
		printf("%c", c);
	}

	return 0;
}
