/**
 * SO, 2010 - Lab #2, Simple I/O
 * Task #3, Windows
 *
 * mcat - read a file and print on the standard output 
 */

#include <windows.h>
#include <stdio.h>

#define BUF_SIZE 8

int main(int argc, char *argv[])
{
	HANDLE fHandle;
	CHAR buf[BUF_SIZE];
	DWORD bytesRead, bytesWritten;

	if (argc != 2) {
		fprintf(stderr,"Usage: ./mcat <file>\n");
		exit(EXIT_FAILURE);
	}
	
	/* open file with name pointed by argv[1] */
	fHandle = CreateFile(argv[1],
			GENERIC_READ,
			0,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL);
	if (fHandle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "Error opening file %d\n", GetLastError());
		ExitProcess(1);
	}

	/* read file pointed by argv[1] and send it to standadard output *
	 * WARN: you must read at most BUF_SIZE bytes at a time
       	 */

	while (1) {
		if (ReadFile(fHandle,
			buf,
			BUF_SIZE,
			&bytesRead,
			NULL) == FALSE) {
				fprintf(stderr, "Error reading file %d\n", GetLastError());
				ExitProcess(1);
		}

		if (bytesRead == 0)
			break;

		if (WriteFile(GetStdHandle(STD_OUTPUT_HANDLE),
			buf,
			bytesRead,
			&bytesWritten,
			NULL) == FALSE) {
				fprintf(stderr, "Error reading file %d\n", GetLastError());
				ExitProcess(1);
		}
	}

	return 0;
}