/** 
 * SO, 2010 - Lab #2, Simple I/O
 * Task #1, Windows
 *
 * Reading a character from a specified position 
 */

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

static void HandleError (void)
 {
        CHAR errBuf[1024];
 
        FormatMessage(
                FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_MAX_WIDTH_MASK,
                NULL,			/* nicio definire a mesajului */
                GetLastError(),
                0,
                errBuf, sizeof(errBuf) - 1,
                NULL);			/* fara argumente variabile */
 
  	fprintf (stderr, "%s\n", errBuf);
 }


static int pos[] = 
{ 
	100, 200, 300, 400, 500, 600, 700, 800, 900, 
	1000, 1100, 1200, 1300, 1400, 1500, 1600, 1700, 1800, 1900,
	2000, 2100, 2200, 2300, 2400, 2500, 2600, 2700, 2800, 2900,
	3000, 3100, 3200, 3300  
};

int main(void)
{
	HANDLE fHandle;
	int i, pos_size = sizeof(pos) / sizeof(pos[0]); /* number of elements in pos array */
	DWORD currentPosition;
	DWORD bytesRead, bytesWritten;
	DWORD retRead, retWrite;
	TCHAR c;
	HANDLE outHandle = GetStdHandle(STD_OUTPUT_HANDLE);
	
	/* open quotes.txt for reading */
	fHandle = CreateFile(
            "quotes.txt",
            GENERIC_READ,
            FILE_SHARE_READ,
            NULL,	/* fara atribute de securitate */
            OPEN_EXISTING,
            FILE_ATTRIBUTE_NORMAL,
            NULL	/* fara sablon */
    );
    if (fHandle == INVALID_HANDLE_VALUE) {
       HandleError();
       ExitProcess(-1);
    }

	
	/* 
	 * read characters from positions specified by pos 
	 * and write them to standard output
         */	

	for (i = 0; i < pos_size; i++){
		currentPosition = SetFilePointer(
            fHandle,
            pos[i],
            NULL,	/* caz pozitionare pe 64 biti */
            FILE_BEGIN
		);

		if (currentPosition == INVALID_SET_FILE_POINTER) {
			HandleError();
			ExitProcess (-1);
		}

		retRead = ReadFile(
            fHandle,
            &c,
            1,
            &bytesRead,
            NULL);	/* nimic asincron */
		if (retRead == FALSE) {
				HandleError();  /* functie de tratare a erorii */
				ExitProcess (-1);
		}

		retWrite = WriteFile(
			outHandle,
			&c,
			1,
			&bytesWritten,
			NULL);
		if (retWrite == FALSE) {
				HandleError();
				ExitProcess(-1);
		}
	}

	return 0;
}
	
	
