/**
 * SO, 2010 - Lab 2, Simple I/O
 * Task #2, Windows
 *
 * Full length read/write 
 */

#include "xfile.h"
#include <windows.h>
#include <stdio.h>

#define BUF_SIZE 1024

// Print last error
void PrintError(const char *msg)
{
	CHAR errBuf[1024];

       FormatMessage(
               FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_MAX_WIDTH_MASK,
               NULL,
               GetLastError(),
               0,
               errBuf, sizeof(errBuf) - 1,
               NULL);

	   fprintf (stderr, "eroare @%s: %s\n", msg, errBuf);
}

int main(int argc, char **argv) {
	int i;
	char buf[BUF_SIZE];
    HANDLE fd;
    DWORD bytesRead;

	for (i = 0; i < BUF_SIZE; i++)
		buf[i] = i % 256;

    fd = CreateFile("xtest.bin", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (fd == INVALID_HANDLE_VALUE) {
		PrintError("Eroare la deschiderea xtest.bin pentru scriere");
		return -1;
	}

	if (!xWriteFile(fd, buf, BUF_SIZE)) {
        PrintError("Eroare la scrierea in xtest.bin");
		return -1;
	}

	if (!CloseHandle(fd)) {
		PrintError("Eroare la inchiderea xtest.bin (1)");
		return -1;
	}

	fd = CreateFile("xtest.bin", GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (fd == INVALID_HANDLE_VALUE) {
		PrintError("Eroare la deschiderea xtest.bin pentru citire");
		return -1;
	}
    
    for (i = 0; i < BUF_SIZE; i++)
        buf[i] = (i+1) % 256;

	if (!xReadFile(fd, buf, BUF_SIZE, &bytesRead)) {
		PrintError("Eroare la citirea din xtest.bin");
		return -1;
	}
    
    if (bytesRead != BUF_SIZE) {
        PrintError("Nu au fost cititi suficienti octeti din xtest.bin");
        return -1;
    }

	if (!CloseHandle(fd)) {
		PrintError("Eroare la inchiderea xtest.bin (2)");
		return -1;
	}

	for (i = 0; i < BUF_SIZE; i++)
		if (buf[i] != (char)(i % 256)) {
			printf("Datele citite nu coincid cu cele scrise!\n");
			return -1;
		}

	printf("OK!\n");
	return 0;
}

