/**
 * SO, 2010 - Lab #2, Simple I/O
 * Task #3, Windows
 *
 * mcat - read a file and print on the standard output 
 */

#include <windows.h>
#include <stdio.h>
#include <string.h>

#define BUF_SIZE 8

static void HandleError (void)
 {
        CHAR errBuf[1024];
 
        FormatMessage(
                FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_MAX_WIDTH_MASK,
                NULL,			/* nicio definire a mesajului */
                GetLastError(),
                0,
                errBuf, sizeof(errBuf) - 1,
                NULL);			/* fara argumente variabile */
 
  		fprintf (stderr, "%s\n", errBuf);
 }


int main(int argc, char *argv[])
{
	HANDLE fHandle;
	DWORD bytesRd = 0, bytesWritten;
	DWORD retRead = 0, retWrite;
	char* buffer[BUF_SIZE];
	HANDLE outHandle = GetStdHandle(STD_OUTPUT_HANDLE);

	if (argc != 2) {
		fprintf(stderr,"Usage: ./mcat <file>\n");
		exit(EXIT_FAILURE);
	}
	
	/* open file with name pointed by argv[1] */
	fHandle = CreateFile(
            argv[1],
            GENERIC_READ,
            FILE_SHARE_READ,
            NULL,	/* fara atribute de securitate */
            OPEN_EXISTING,
            FILE_ATTRIBUTE_NORMAL,
            NULL	/* fara sablon */
    );
    if (fHandle == INVALID_HANDLE_VALUE) {
       HandleError();
       ExitProcess(-1);
    }

	/* read file pointed by argv[1] and send it to standadard output *
	 * WARN: you must read at most BUF_SIZE bytes at a time
       	 */

	do {
		retRead = ReadFile(
            fHandle,
            &buffer,
            BUF_SIZE,
            &bytesRd,
            NULL);	/* nimic asincron */
		if (retRead == FALSE) {
				HandleError();  /* functie de tratare a erorii */
				ExitProcess (-1);
		}

		retWrite = WriteFile(
			outHandle,
			buffer,
			bytesRd,
			&bytesWritten,
			NULL);
		if (retWrite == FALSE) {
				HandleError();
				ExitProcess(-1);
		}
	} while (bytesRd > 0);

	CloseHandle(fHandle);
	CloseHandle(outHandle);

	return 0;
}
